/* project-dialog-remove.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <nicolas.joseph@valaide.org>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>


#define VALIDE_TYPE_ABSTRACT_PROJECT_DIALOG_REMOVE (valide_abstract_project_dialog_remove_get_type ())
#define VALIDE_ABSTRACT_PROJECT_DIALOG_REMOVE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_ABSTRACT_PROJECT_DIALOG_REMOVE, ValideAbstractProjectDialogRemove))
#define VALIDE_ABSTRACT_PROJECT_DIALOG_REMOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_ABSTRACT_PROJECT_DIALOG_REMOVE, ValideAbstractProjectDialogRemoveClass))
#define VALIDE_IS_ABSTRACT_PROJECT_DIALOG_REMOVE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_ABSTRACT_PROJECT_DIALOG_REMOVE))
#define VALIDE_IS_ABSTRACT_PROJECT_DIALOG_REMOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_ABSTRACT_PROJECT_DIALOG_REMOVE))
#define VALIDE_ABSTRACT_PROJECT_DIALOG_REMOVE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_ABSTRACT_PROJECT_DIALOG_REMOVE, ValideAbstractProjectDialogRemoveClass))

typedef struct _ValideAbstractProjectDialogRemove ValideAbstractProjectDialogRemove;
typedef struct _ValideAbstractProjectDialogRemoveClass ValideAbstractProjectDialogRemoveClass;
typedef struct _ValideAbstractProjectDialogRemovePrivate ValideAbstractProjectDialogRemovePrivate;

#define VALIDE_ABSTRACT_PROJECT_DIALOG_REMOVE_TYPE_WINDOW_WIDGETS (valide_abstract_project_dialog_remove_window_widgets_get_type ())
#define VALIDE_ABSTRACT_PROJECT_DIALOG_REMOVE_WINDOW_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_ABSTRACT_PROJECT_DIALOG_REMOVE_TYPE_WINDOW_WIDGETS, ValideAbstractProjectDialogRemovewindow_widgets))
#define VALIDE_ABSTRACT_PROJECT_DIALOG_REMOVE_WINDOW_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_ABSTRACT_PROJECT_DIALOG_REMOVE_TYPE_WINDOW_WIDGETS, ValideAbstractProjectDialogRemovewindow_widgetsClass))
#define VALIDE_ABSTRACT_PROJECT_DIALOG_REMOVE_IS_WINDOW_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_ABSTRACT_PROJECT_DIALOG_REMOVE_TYPE_WINDOW_WIDGETS))
#define VALIDE_ABSTRACT_PROJECT_DIALOG_REMOVE_IS_WINDOW_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_ABSTRACT_PROJECT_DIALOG_REMOVE_TYPE_WINDOW_WIDGETS))
#define VALIDE_ABSTRACT_PROJECT_DIALOG_REMOVE_WINDOW_WIDGETS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_ABSTRACT_PROJECT_DIALOG_REMOVE_TYPE_WINDOW_WIDGETS, ValideAbstractProjectDialogRemovewindow_widgetsClass))

typedef struct _ValideAbstractProjectDialogRemovewindow_widgets ValideAbstractProjectDialogRemovewindow_widgets;
typedef struct _ValideAbstractProjectDialogRemovewindow_widgetsClass ValideAbstractProjectDialogRemovewindow_widgetsClass;

#define VALIDE_TYPE_PROJECT_DIALOG_REMOVE (valide_project_dialog_remove_get_type ())
#define VALIDE_PROJECT_DIALOG_REMOVE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PROJECT_DIALOG_REMOVE, ValideProjectDialogRemove))
#define VALIDE_PROJECT_DIALOG_REMOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PROJECT_DIALOG_REMOVE, ValideProjectDialogRemoveClass))
#define VALIDE_IS_PROJECT_DIALOG_REMOVE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PROJECT_DIALOG_REMOVE))
#define VALIDE_IS_PROJECT_DIALOG_REMOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PROJECT_DIALOG_REMOVE))
#define VALIDE_PROJECT_DIALOG_REMOVE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PROJECT_DIALOG_REMOVE, ValideProjectDialogRemoveClass))

typedef struct _ValideProjectDialogRemove ValideProjectDialogRemove;
typedef struct _ValideProjectDialogRemoveClass ValideProjectDialogRemoveClass;
typedef struct _ValideProjectDialogRemovePrivate ValideProjectDialogRemovePrivate;

#define VALIDE_TYPE_PROJECT (valide_project_get_type ())
#define VALIDE_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PROJECT, ValideProject))
#define VALIDE_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PROJECT, ValideProjectClass))
#define VALIDE_IS_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PROJECT))
#define VALIDE_IS_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PROJECT))
#define VALIDE_PROJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PROJECT, ValideProjectClass))

typedef struct _ValideProject ValideProject;
typedef struct _ValideProjectClass ValideProjectClass;
typedef struct _ValideAbstractProjectDialogRemovewindow_widgetsPrivate ValideAbstractProjectDialogRemovewindow_widgetsPrivate;

#define G_YAML_TYPE_BUILDABLE (g_yaml_buildable_get_type ())
#define G_YAML_BUILDABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_YAML_TYPE_BUILDABLE, GYAMLBuildable))
#define G_YAML_IS_BUILDABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_YAML_TYPE_BUILDABLE))
#define G_YAML_BUILDABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), G_YAML_TYPE_BUILDABLE, GYAMLBuildableIface))

typedef struct _GYAMLBuildable GYAMLBuildable;
typedef struct _GYAMLBuildableIface GYAMLBuildableIface;

#define G_YAML_TYPE_BUILDER (g_yaml_builder_get_type ())
#define G_YAML_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_YAML_TYPE_BUILDER, GYAMLBuilder))
#define G_YAML_BUILDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), G_YAML_TYPE_BUILDER, GYAMLBuilderClass))
#define G_YAML_IS_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_YAML_TYPE_BUILDER))
#define G_YAML_IS_BUILDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), G_YAML_TYPE_BUILDER))
#define G_YAML_BUILDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), G_YAML_TYPE_BUILDER, GYAMLBuilderClass))

typedef struct _GYAMLBuilder GYAMLBuilder;
typedef struct _GYAMLBuilderClass GYAMLBuilderClass;

#define G_YAML_TYPE_NODE (g_yaml_node_get_type ())
#define G_YAML_NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_YAML_TYPE_NODE, GYAMLNode))
#define G_YAML_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), G_YAML_TYPE_NODE, GYAMLNodeClass))
#define G_YAML_IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_YAML_TYPE_NODE))
#define G_YAML_IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), G_YAML_TYPE_NODE))
#define G_YAML_NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), G_YAML_TYPE_NODE, GYAMLNodeClass))

typedef struct _GYAMLNode GYAMLNode;
typedef struct _GYAMLNodeClass GYAMLNodeClass;
typedef struct _ValideProjectPrivate ValideProjectPrivate;

#define VALIDE_TYPE_BUILDER_MANAGER (valide_builder_manager_get_type ())
#define VALIDE_BUILDER_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_BUILDER_MANAGER, ValideBuilderManager))
#define VALIDE_BUILDER_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_BUILDER_MANAGER, ValideBuilderManagerClass))
#define VALIDE_IS_BUILDER_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_BUILDER_MANAGER))
#define VALIDE_IS_BUILDER_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_BUILDER_MANAGER))
#define VALIDE_BUILDER_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_BUILDER_MANAGER, ValideBuilderManagerClass))

typedef struct _ValideBuilderManager ValideBuilderManager;
typedef struct _ValideBuilderManagerClass ValideBuilderManagerClass;

#define VALIDE_TYPE_SOURCE (valide_source_get_type ())
#define VALIDE_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_SOURCE, ValideSource))
#define VALIDE_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_SOURCE, ValideSourceClass))
#define VALIDE_IS_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_SOURCE))
#define VALIDE_IS_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_SOURCE))
#define VALIDE_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_SOURCE, ValideSourceClass))

typedef struct _ValideSource ValideSource;
typedef struct _ValideSourceClass ValideSourceClass;

#define VALIDE_TYPE_PACKAGE (valide_package_get_type ())
#define VALIDE_PACKAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PACKAGE, ValidePackage))
#define VALIDE_PACKAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PACKAGE, ValidePackageClass))
#define VALIDE_IS_PACKAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PACKAGE))
#define VALIDE_IS_PACKAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PACKAGE))
#define VALIDE_PACKAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PACKAGE, ValidePackageClass))

typedef struct _ValidePackage ValidePackage;
typedef struct _ValidePackageClass ValidePackageClass;

#define VALIDE_TYPE_VAPI_DIR (valide_vapi_dir_get_type ())
#define VALIDE_VAPI_DIR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_VAPI_DIR, ValideVapiDir))
#define VALIDE_VAPI_DIR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_VAPI_DIR, ValideVapiDirClass))
#define VALIDE_IS_VAPI_DIR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_VAPI_DIR))
#define VALIDE_IS_VAPI_DIR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_VAPI_DIR))
#define VALIDE_VAPI_DIR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_VAPI_DIR, ValideVapiDirClass))

typedef struct _ValideVapiDir ValideVapiDir;
typedef struct _ValideVapiDirClass ValideVapiDirClass;

struct _ValideAbstractProjectDialogRemove {
	GtkObject parent_instance;
	ValideAbstractProjectDialogRemovePrivate * priv;
	char* name_space;
	GtkBuilder* xml;
	ValideAbstractProjectDialogRemovewindow_widgets* widgets;
};

struct _ValideAbstractProjectDialogRemoveClass {
	GtkObjectClass parent_class;
};

/**
 * A dialog box for remove a file from a project
 */
struct _ValideProjectDialogRemove {
	ValideAbstractProjectDialogRemove parent_instance;
	ValideProjectDialogRemovePrivate * priv;
};

struct _ValideProjectDialogRemoveClass {
	ValideAbstractProjectDialogRemoveClass parent_class;
};

struct _ValideProjectDialogRemovePrivate {
	GtkListStore* list_store;
	ValideProject* _project;
	GList* _selected_files;
};

struct _ValideAbstractProjectDialogRemovewindow_widgets {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ValideAbstractProjectDialogRemovewindow_widgetsPrivate * priv;
	GtkDialog* dialog;
	GtkVBox* vbox;
	GtkLabel* label;
	GtkScrolledWindow* scrolled_window;
	GtkTreeView* tree_view;
	GtkHButtonBox* dialog_action_area;
	GtkButton* button1;
	GtkButton* button2;
};

struct _ValideAbstractProjectDialogRemovewindow_widgetsClass {
	GTypeClass parent_class;
	void (*finalize) (ValideAbstractProjectDialogRemovewindow_widgets *self);
};

/**
 * Buildable GObjects, from YAML.
 *
 *
 * Objects that implements GLib.YAML.Buildable is buildable by
 * GLib.YAML.Builder.
 *
 * This interface is almost the same as GtkBuildable.
 *
 **/
struct _GYAMLBuildableIface {
	GTypeInterface parent_iface;
	const char* (*get_name) (GYAMLBuildable* self);
	void (*set_name) (GYAMLBuildable* self, const char* name);
	void (*add_child) (GYAMLBuildable* self, GYAMLBuilder* builder, GObject* child, const char* type, GError** error);
	char** (*get_child_tags) (GYAMLBuildable* self, int* result_length1);
	GType* (*get_child_types) (GYAMLBuildable* self, int* result_length1);
	GList* (*get_children) (GYAMLBuildable* self, const char* type);
	GObject* (*get_internal_child) (GYAMLBuildable* self, GYAMLBuilder* builder, const char* child_name);
	void (*custom_node) (GYAMLBuildable* self, GYAMLBuilder* builder, const char* tag, GYAMLNode* node, GError** error);
};

/**
 * A class for project
 */
struct _ValideProject {
	GObject parent_instance;
	ValideProjectPrivate * priv;
	char* filename;
	ValideBuilderManager* builders;
	GList* files;
	GList* packages;
	GList* vapi_dir;
};

struct _ValideProjectClass {
	GObjectClass parent_class;
};


static gpointer valide_project_dialog_remove_parent_class = NULL;

GType valide_abstract_project_dialog_remove_get_type (void);
gpointer valide_abstract_project_dialog_remove_window_widgets_ref (gpointer instance);
void valide_abstract_project_dialog_remove_window_widgets_unref (gpointer instance);
GParamSpec* valide_abstract_project_dialog_remove_param_spec_window_widgets (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void valide_abstract_project_dialog_remove_value_set_window_widgets (GValue* value, gpointer v_object);
gpointer valide_abstract_project_dialog_remove_value_get_window_widgets (const GValue* value);
GType valide_abstract_project_dialog_remove_window_widgets_get_type (void);
GType valide_project_dialog_remove_get_type (void);
GType valide_project_get_type (void);
#define VALIDE_PROJECT_DIALOG_REMOVE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALIDE_TYPE_PROJECT_DIALOG_REMOVE, ValideProjectDialogRemovePrivate))
enum  {
	VALIDE_PROJECT_DIALOG_REMOVE_DUMMY_PROPERTY,
	VALIDE_PROJECT_DIALOG_REMOVE_PROJECT,
	VALIDE_PROJECT_DIALOG_REMOVE_SELECTED_FILES
};
static void _g_list_free_g_free (GList* self);
static void valide_project_dialog_remove_toggled (ValideProjectDialogRemove* self, GtkCellRendererToggle* sender, const char* path);
static void valide_project_dialog_remove_set_project (ValideProjectDialogRemove* self, ValideProject* value);
ValideProjectDialogRemove* valide_project_dialog_remove_new (ValideProject* project);
ValideProjectDialogRemove* valide_project_dialog_remove_construct (GType object_type, ValideProject* project);
gint valide_project_dialog_remove_run (ValideProjectDialogRemove* self);
void valide_project_dialog_remove_destroy (ValideProjectDialogRemove* self);
void valide_project_dialog_remove_hide (ValideProjectDialogRemove* self);
ValideProject* valide_project_dialog_remove_get_project (ValideProjectDialogRemove* self);
GList* valide_project_dialog_remove_get_selected_files (ValideProjectDialogRemove* self);
static void _valide_project_dialog_remove_toggled_gtk_cell_renderer_toggle_toggled (GtkCellRendererToggle* _sender, const char* path, gpointer self);
const char* valide_project_get_name (ValideProject* self);
GType g_yaml_builder_get_type (void);
gpointer g_yaml_node_ref (gpointer instance);
void g_yaml_node_unref (gpointer instance);
GParamSpec* g_yaml_param_spec_node (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void g_yaml_value_set_node (GValue* value, gpointer v_object);
gpointer g_yaml_value_get_node (const GValue* value);
GType g_yaml_node_get_type (void);
GType g_yaml_buildable_get_type (void);
GType valide_builder_manager_get_type (void);
GType valide_source_get_type (void);
GType valide_package_get_type (void);
GType valide_vapi_dir_get_type (void);
const char* valide_source_get_path (ValideSource* self);
static GObject * valide_project_dialog_remove_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void valide_project_dialog_remove_finalize (GObject* obj);
static void valide_project_dialog_remove_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void valide_project_dialog_remove_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);



static void _g_list_free_g_free (GList* self) {
	g_list_foreach (self, (GFunc) g_free, NULL);
	g_list_free (self);
}


#line 68 "project-dialog-remove.vala"
static void valide_project_dialog_remove_toggled (ValideProjectDialogRemove* self, GtkCellRendererToggle* sender, const char* path) {
#line 289 "project-dialog-remove.c"
	GtkTreeIter iter = {0};
	gboolean enable;
#line 68 "project-dialog-remove.vala"
	g_return_if_fail (self != NULL);
#line 68 "project-dialog-remove.vala"
	g_return_if_fail (sender != NULL);
#line 68 "project-dialog-remove.vala"
	g_return_if_fail (path != NULL);
#line 298 "project-dialog-remove.c"
	enable = FALSE;
#line 73 "project-dialog-remove.vala"
	gtk_tree_model_get_iter_from_string ((GtkTreeModel*) self->priv->list_store, &iter, path);
#line 74 "project-dialog-remove.vala"
	gtk_tree_model_get ((GtkTreeModel*) self->priv->list_store, &iter, 0, &enable, -1, -1);
#line 75 "project-dialog-remove.vala"
	gtk_list_store_set (self->priv->list_store, &iter, 0, !enable, -1, -1);
#line 306 "project-dialog-remove.c"
}


/**
   * Create a new Valide.ProjectDialogRemove
   *
   * @param project The attached project
   */
#line 83 "project-dialog-remove.vala"
ValideProjectDialogRemove* valide_project_dialog_remove_construct (GType object_type, ValideProject* project) {
#line 317 "project-dialog-remove.c"
	GParameter * __params;
	GParameter * __params_it;
	ValideProjectDialogRemove * self;
#line 83 "project-dialog-remove.vala"
	g_return_val_if_fail (project != NULL, NULL);
#line 323 "project-dialog-remove.c"
	__params = g_new0 (GParameter, 1);
	__params_it = __params;
#line 85 "project-dialog-remove.vala"
	__params_it->name = "project";
#line 85 "project-dialog-remove.vala"
	g_value_init (&__params_it->value, VALIDE_TYPE_PROJECT);
#line 85 "project-dialog-remove.vala"
	g_value_set_object (&__params_it->value, project);
#line 85 "project-dialog-remove.vala"
	__params_it++;
#line 334 "project-dialog-remove.c"
	self = g_object_newv (object_type, __params_it - __params, __params);
	while (__params_it > __params) {
		--__params_it;
		g_value_unset (&__params_it->value);
	}
	g_free (__params);
	return self;
}


#line 83 "project-dialog-remove.vala"
ValideProjectDialogRemove* valide_project_dialog_remove_new (ValideProject* project) {
#line 83 "project-dialog-remove.vala"
	return valide_project_dialog_remove_construct (VALIDE_TYPE_PROJECT_DIALOG_REMOVE, project);
#line 349 "project-dialog-remove.c"
}


/**
   * @see Gtk.Dialog.run
   */
#line 118 "project-dialog-remove.vala"
gint valide_project_dialog_remove_run (ValideProjectDialogRemove* self) {
#line 358 "project-dialog-remove.c"
	gint result;
#line 118 "project-dialog-remove.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 120 "project-dialog-remove.vala"
	gtk_widget_show_all ((GtkWidget*) ((ValideAbstractProjectDialogRemove*) self)->widgets->dialog);
#line 364 "project-dialog-remove.c"
	result = gtk_dialog_run (((ValideAbstractProjectDialogRemove*) self)->widgets->dialog);
	return result;
}


/**
   * @see Gtk.Object.destroy
   */
#line 127 "project-dialog-remove.vala"
void valide_project_dialog_remove_destroy (ValideProjectDialogRemove* self) {
#line 127 "project-dialog-remove.vala"
	g_return_if_fail (self != NULL);
#line 129 "project-dialog-remove.vala"
	gtk_object_destroy ((GtkObject*) ((ValideAbstractProjectDialogRemove*) self)->widgets->dialog);
#line 379 "project-dialog-remove.c"
}


/**
   * @see Gtk.Widget.hide
   */
#line 135 "project-dialog-remove.vala"
void valide_project_dialog_remove_hide (ValideProjectDialogRemove* self) {
#line 135 "project-dialog-remove.vala"
	g_return_if_fail (self != NULL);
#line 137 "project-dialog-remove.vala"
	gtk_widget_hide ((GtkWidget*) ((ValideAbstractProjectDialogRemove*) self)->widgets->dialog);
#line 392 "project-dialog-remove.c"
}


ValideProject* valide_project_dialog_remove_get_project (ValideProjectDialogRemove* self) {
	ValideProject* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_project;
	return result;
}


static void valide_project_dialog_remove_set_project (ValideProjectDialogRemove* self, ValideProject* value) {
	ValideProject* _tmp1_;
	ValideProject* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp1_ = NULL;
#line 35 "project-dialog-remove.vala"
	_tmp0_ = NULL;
#line 411 "project-dialog-remove.c"
	self->priv->_project = (_tmp1_ = (_tmp0_ = value, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (self->priv->_project == NULL) ? NULL : (self->priv->_project = (g_object_unref (self->priv->_project), NULL)), _tmp1_);
	g_object_notify ((GObject *) self, "project");
}


GList* valide_project_dialog_remove_get_selected_files (ValideProjectDialogRemove* self) {
	GList* result;
	GtkTreeIter iter = {0};
	GList* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = NULL;
#line 48 "project-dialog-remove.vala"
	self->priv->_selected_files = (_tmp0_ = NULL, (self->priv->_selected_files == NULL) ? NULL : (self->priv->_selected_files = (_g_list_free_g_free (self->priv->_selected_files), NULL)), _tmp0_);
#line 425 "project-dialog-remove.c"
	/* @fixme Error if no file */
#line 50 "project-dialog-remove.vala"
	gtk_tree_model_get_iter_first ((GtkTreeModel*) self->priv->list_store, &iter);
#line 429 "project-dialog-remove.c"
	{
		gboolean _tmp1_;
		_tmp1_ = TRUE;
#line 51 "project-dialog-remove.vala"
		while (TRUE) {
#line 435 "project-dialog-remove.c"
			gboolean enable;
#line 51 "project-dialog-remove.vala"
			if (!_tmp1_) {
#line 63 "project-dialog-remove.vala"
				if (!(gtk_tree_model_iter_next ((GtkTreeModel*) self->priv->list_store, &iter) == TRUE)) {
#line 63 "project-dialog-remove.vala"
					break;
#line 443 "project-dialog-remove.c"
				}
			}
#line 51 "project-dialog-remove.vala"
			_tmp1_ = FALSE;
#line 448 "project-dialog-remove.c"
			enable = FALSE;
#line 55 "project-dialog-remove.vala"
			gtk_tree_model_get ((GtkTreeModel*) self->priv->list_store, &iter, 0, &enable, -1, -1);
#line 56 "project-dialog-remove.vala"
			if (enable) {
#line 454 "project-dialog-remove.c"
				char* file;
				const char* _tmp2_;
				file = g_strdup ("");
#line 60 "project-dialog-remove.vala"
				gtk_tree_model_get ((GtkTreeModel*) self->priv->list_store, &iter, 1, &file, -1, -1);
#line 61 "project-dialog-remove.vala"
				_tmp2_ = NULL;
#line 61 "project-dialog-remove.vala"
				self->priv->_selected_files = g_list_append (self->priv->_selected_files, (_tmp2_ = file, (_tmp2_ == NULL) ? NULL : g_strdup (_tmp2_)));
#line 464 "project-dialog-remove.c"
				file = (g_free (file), NULL);
			}
		}
	}
	result = self->priv->_selected_files;
	return result;
}


#line 68 "project-dialog-remove.vala"
static void _valide_project_dialog_remove_toggled_gtk_cell_renderer_toggle_toggled (GtkCellRendererToggle* _sender, const char* path, gpointer self) {
#line 476 "project-dialog-remove.c"
	valide_project_dialog_remove_toggled (self, _sender, path);
}


static GObject * valide_project_dialog_remove_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	ValideProjectDialogRemoveClass * klass;
	GObjectClass * parent_class;
	ValideProjectDialogRemove * self;
	klass = VALIDE_PROJECT_DIALOG_REMOVE_CLASS (g_type_class_peek (VALIDE_TYPE_PROJECT_DIALOG_REMOVE));
	parent_class = G_OBJECT_CLASS (g_type_class_peek_parent (klass));
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = VALIDE_PROJECT_DIALOG_REMOVE (obj);
	{
		GtkListStore* _tmp0_;
		GtkTreeView* _tmp1_;
		GtkTreeView* tree_view;
		GtkCellRendererToggle* render1;
		GtkTreeViewColumn* column;
		GtkCellRendererText* render2;
		GtkTreeViewColumn* _tmp2_;
		char* _tmp3_;
		_tmp0_ = NULL;
#line 90 "project-dialog-remove.vala"
		self->priv->list_store = (_tmp0_ = gtk_list_store_new (2, G_TYPE_BOOLEAN, G_TYPE_STRING, NULL), (self->priv->list_store == NULL) ? NULL : (self->priv->list_store = (g_object_unref (self->priv->list_store), NULL)), _tmp0_);
#line 92 "project-dialog-remove.vala"
		_tmp1_ = NULL;
#line 504 "project-dialog-remove.c"
		tree_view = (_tmp1_ = ((ValideAbstractProjectDialogRemove*) self)->widgets->tree_view, (_tmp1_ == NULL) ? NULL : g_object_ref (_tmp1_));
#line 93 "project-dialog-remove.vala"
		gtk_tree_view_set_model (tree_view, (GtkTreeModel*) self->priv->list_store);
#line 508 "project-dialog-remove.c"
		render1 = g_object_ref_sink ((GtkCellRendererToggle*) gtk_cell_renderer_toggle_new ());
		column = g_object_ref_sink (gtk_tree_view_column_new_with_attributes (_ ("Remove"), (GtkCellRenderer*) render1, "active", 0, NULL, NULL));
#line 97 "project-dialog-remove.vala"
		gtk_tree_view_append_column (tree_view, column);
#line 98 "project-dialog-remove.vala"
		g_signal_connect_object (render1, "toggled", (GCallback) _valide_project_dialog_remove_toggled_gtk_cell_renderer_toggle_toggled, self, 0);
#line 515 "project-dialog-remove.c"
		render2 = g_object_ref_sink ((GtkCellRendererText*) gtk_cell_renderer_text_new ());
		_tmp2_ = NULL;
#line 101 "project-dialog-remove.vala"
		column = (_tmp2_ = g_object_ref_sink (gtk_tree_view_column_new_with_attributes (_ ("File"), (GtkCellRenderer*) render2, "text", 1, NULL, NULL)), (column == NULL) ? NULL : (column = (g_object_unref (column), NULL)), _tmp2_);
#line 102 "project-dialog-remove.vala"
		gtk_tree_view_append_column (tree_view, column);
#line 103 "project-dialog-remove.vala"
		gtk_tree_view_set_headers_visible (tree_view, FALSE);
#line 820 "glib-2.0.vapi"
		_tmp3_ = NULL;
#line 105 "project-dialog-remove.vala"
		gtk_label_set_text (((ValideAbstractProjectDialogRemove*) self)->widgets->label, _tmp3_ = g_strdup_printf (_ ("Select files to remove from %s:"), valide_project_get_name (self->priv->_project)));
#line 528 "project-dialog-remove.c"
		_tmp3_ = (g_free (_tmp3_), NULL);
		{
			GList* file_collection;
			GList* file_it;
#line 106 "project-dialog-remove.vala"
			file_collection = self->priv->_project->files;
#line 535 "project-dialog-remove.c"
			for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
				ValideSource* _tmp4_;
				ValideSource* file;
#line 72 "project.vala"
				_tmp4_ = NULL;
#line 106 "project-dialog-remove.vala"
				file = (_tmp4_ = (ValideSource*) file_it->data, (_tmp4_ == NULL) ? NULL : g_object_ref (_tmp4_));
#line 543 "project-dialog-remove.c"
				{
					GtkTreeIter iter = {0};
#line 110 "project-dialog-remove.vala"
					gtk_list_store_append (self->priv->list_store, &iter);
#line 111 "project-dialog-remove.vala"
					gtk_list_store_set (self->priv->list_store, &iter, 0, FALSE, 1, valide_source_get_path (file), -1);
#line 550 "project-dialog-remove.c"
					(file == NULL) ? NULL : (file = (g_object_unref (file), NULL));
				}
			}
		}
		(tree_view == NULL) ? NULL : (tree_view = (g_object_unref (tree_view), NULL));
		(render1 == NULL) ? NULL : (render1 = (g_object_unref (render1), NULL));
		(column == NULL) ? NULL : (column = (g_object_unref (column), NULL));
		(render2 == NULL) ? NULL : (render2 = (g_object_unref (render2), NULL));
	}
	return obj;
}


static void valide_project_dialog_remove_class_init (ValideProjectDialogRemoveClass * klass) {
	valide_project_dialog_remove_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValideProjectDialogRemovePrivate));
	G_OBJECT_CLASS (klass)->get_property = valide_project_dialog_remove_get_property;
	G_OBJECT_CLASS (klass)->set_property = valide_project_dialog_remove_set_property;
	G_OBJECT_CLASS (klass)->constructor = valide_project_dialog_remove_constructor;
	G_OBJECT_CLASS (klass)->finalize = valide_project_dialog_remove_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_PROJECT_DIALOG_REMOVE_PROJECT, g_param_spec_object ("project", "project", "project", VALIDE_TYPE_PROJECT, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_PROJECT_DIALOG_REMOVE_SELECTED_FILES, g_param_spec_pointer ("selected-files", "selected-files", "selected-files", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void valide_project_dialog_remove_instance_init (ValideProjectDialogRemove * self) {
	self->priv = VALIDE_PROJECT_DIALOG_REMOVE_GET_PRIVATE (self);
}


static void valide_project_dialog_remove_finalize (GObject* obj) {
	ValideProjectDialogRemove * self;
	self = VALIDE_PROJECT_DIALOG_REMOVE (obj);
	(self->priv->list_store == NULL) ? NULL : (self->priv->list_store = (g_object_unref (self->priv->list_store), NULL));
	(self->priv->_project == NULL) ? NULL : (self->priv->_project = (g_object_unref (self->priv->_project), NULL));
	(self->priv->_selected_files == NULL) ? NULL : (self->priv->_selected_files = (_g_list_free_g_free (self->priv->_selected_files), NULL));
	G_OBJECT_CLASS (valide_project_dialog_remove_parent_class)->finalize (obj);
}


GType valide_project_dialog_remove_get_type (void) {
	static GType valide_project_dialog_remove_type_id = 0;
	if (valide_project_dialog_remove_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValideProjectDialogRemoveClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valide_project_dialog_remove_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValideProjectDialogRemove), 0, (GInstanceInitFunc) valide_project_dialog_remove_instance_init, NULL };
		valide_project_dialog_remove_type_id = g_type_register_static (VALIDE_TYPE_ABSTRACT_PROJECT_DIALOG_REMOVE, "ValideProjectDialogRemove", &g_define_type_info, 0);
	}
	return valide_project_dialog_remove_type_id;
}


static void valide_project_dialog_remove_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ValideProjectDialogRemove * self;
	gpointer boxed;
	self = VALIDE_PROJECT_DIALOG_REMOVE (object);
	switch (property_id) {
		case VALIDE_PROJECT_DIALOG_REMOVE_PROJECT:
		g_value_set_object (value, valide_project_dialog_remove_get_project (self));
		break;
		case VALIDE_PROJECT_DIALOG_REMOVE_SELECTED_FILES:
		g_value_set_pointer (value, valide_project_dialog_remove_get_selected_files (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void valide_project_dialog_remove_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ValideProjectDialogRemove * self;
	self = VALIDE_PROJECT_DIALOG_REMOVE (object);
	switch (property_id) {
		case VALIDE_PROJECT_DIALOG_REMOVE_PROJECT:
		valide_project_dialog_remove_set_project (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}




